<?php

namespace App\Forms\Part;

class SWITCHForm extends PartForm
{
  public function __construct()
  {
    parent::__construct();
  }
  public function form_init_process(string $action, array &$formDatas = []): void
  {
    parent::form_init_process($action, $formDatas);
    $fields = [
      "code",
      "price",
      "status"
    ];
    $filters = [
      'clientinfo_uid',
      'serviceinfo_uid',
      'serverinfo_uid',
      'status'
    ];
    $indexFilter = $filters;
    $batchjobFilters = ['status',];
    $actionButtons = ['view' => ICONS['SEARCH']];
    $batchjobButtons = ['batchjob' => '일괄처리'];
    switch ($action) {
      case 'view':
        $fields = [
          ...$fields,
          'clientinfo_uid',
          'serviceinfo_uid',
          'serverinfo_uid',
          'status',
          'created_at'
        ];
        break;
      case 'index':
      case 'download':
        $fields = [
          ...$fields,
          'clientinfo_uid',
          'serviceinfo_uid',
          'serverinfo_uid',
          'status',
          'created_at'
        ];
        break;
    }
    $this->setFormFields($fields);
    $this->setFormRules($fields);
    $this->setFormFilters($filters);
    $this->setFormOptions($filters, $formDatas);
    $this->setIndexFilters($indexFilter);
    $this->setBatchjobFilters($batchjobFilters);
    $this->setActionButtons($actionButtons);
    $this->setBatchjobButtons($batchjobButtons);
  }
  public function getFormRule(string $field, array $formRules): array
  {
    switch ($field) {
      default:
        $formRules = parent::getFormRule($field, $formRules);
        break;
    }
    return $formRules;
  }
}
